package TJournal::Conf;

# Conf.pm -- author: Oliver Bossert
# Copyright (C) 2004 Oliver Bossert
#
# Paritally based on the work of geniustrader:
# Raphal Hertzog, Fabien Fulhaber
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use strict;
use vars qw(%depconf);

############################################################
sub load {
############################################################
  my ($file) = @_;
  $file = $ENV{'HOME'} . "/.otj/config" if ( !defined($file) );

  return if (! -e $file);

  open (FILE, "< $file") or die "Can not open $file: $!\n";
  while (<FILE>) {
    chomp;
    next if /^\s*#/;
    next if /^\s*$/;
    s/^\s*//; s/\s*$//;
    my ($key, $val) = split /\s+/, $_, 2;
    $depconf{lc($key)} = $val;
  }
  close FILE;
}

############################################################
sub clear { 
############################################################
  %depconf = () 
}

############################################################
sub save {
############################################################
  my ($file) = @_;
  $file = $ENV{'HOME'} . "/.depot/config" if ( !defined($file) );

  open (FILE, "> $file") || die "Can not write to $file: $!\n";
  foreach (sort keys %depconf) {
    print FILE $_ . "\t" . $depconf{$_} . "\n";
  }
  close FILE;
}

############################################################
sub get {
############################################################
  return $depconf{lc($_[0])}; 
}

############################################################
sub set { 
############################################################
  $depconf{lc($_[0])} = $_[1] 
}

############################################################
sub default {
############################################################
  my ($key, $val) = @_;
  $key = lc($key);
  if (! defined($depconf{$key})) {
    $depconf{$key} = $val;
  }
}

############################################################
sub get_first {
############################################################
  my (@keys) = @_;
  foreach (@keys) {
    my $value = get($_);
    if (defined($value) && $value) {
      return $value;
    }
  }
  return "";
}

1;
