package TJournal::DB;

# DB.pm -- author: Oliver Bossert
# Copyright (C) 2004 Oliver Bossert
#
# Paritally based on the work of geniustrader:
# Raphal Hertzog, Fabien Fulhaber
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

use strict;

use TJournal::Conf;

our $loaded_sharenames = 0;
our %sharenames;

TJournal::Conf::default("SharesFile", "./shares");

############################################################
sub new { # Generate a new Object
############################################################
  my $type = shift;
  my $class = ref($type) || $type;
  my $self = {};
  bless $self, $class;

  return $self;
}


############################################################
sub get_db_name {
############################################################
    my ($self, $code) = @_;

    if (! $loaded_sharenames) {
	my $file = TJournal::Conf::get("SharesFile");
	next if (! -e $file);
	open(NAMES, "<$file") || die "Can't open $file : $!\n";
	foreach my $line (<NAMES>) {
	    next if (! $line);
	    my ($c, $d) = split /\t/, $line;
	    if ($c) {
		$sharenames{$c} = $d;
	    }
	}
	close NAMES;
	$loaded_sharenames=1;
    }
    if (exists $sharenames{$code}) {
	return $sharenames{$code};
    }
    return "";
}
